### Enumeration

# FwupdPlugin ContextQuirkSource

#### Declaration

    enum FwupdPlugin.ContextQuirkSource

#### Description [src]

The source of the quirk data, ordered by how good the data is.

#### Members

`FU_CONTEXT_QUIRK_SOURCE_DEVICE`

  From the device itself, perhaps a USB descriptor.

  - Value: `0`
  - Available since: 2.0.2
`FU_CONTEXT_QUIRK_SOURCE_FILE`

  From an internal `.quirk` file.

  - Value: `1`
  - Available since: 2.0.2
`FU_CONTEXT_QUIRK_SOURCE_DB`

  From the database, populated from `usb.ids` and `pci.ids`.

  - Value: `2`
  - Available since: 2.0.2
`FU_CONTEXT_QUIRK_SOURCE_FALLBACK`

  A good fallback, perhaps from the PCI class information.

  - Value: `3`
  - Available since: 2.0.2